Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions

# PartBundle Class Reference

This is the root of a MovingPart hierarchy. More...

Inheritance diagram for PartBundle:

List of all members.

## Public Types
enum | BlendType { BTLinear = 0, BTNormalizedLinear = 1, BTComponentwise = 2, BTComponentwiseQuat = 3 }
## Public Member Functions
| PartBundle (string name)
| Normally, a PartBundle constructor should not be called directly--it will get created when a PartBundleNode is created.
| PartBundle ()
| Normally, a PartBundle constructor should not be called directly--it will get created when a PartBundleNode is created.
PartBundle | applyTransform (TransformState const transform)
| Returns a PartBundle that is a duplicate of this one, but with the indicated transform applied.
AnimControl | bindAnim (AnimBundle anim, int hierarchy_match_flags, PartSubset const subset)
| Binds the animation to the bundle, if possible, and returns a new AnimControl that can be used to start and stop the animation.
AnimControl | bindAnim (AnimBundle anim, int hierarchy_match_flags)
| Binds the animation to the bundle, if possible, and returns a new AnimControl that can be used to start and stop the animation.
AnimControl | bindAnim (AnimBundle anim)
| Binds the animation to the bundle, if possible, and returns a new AnimControl that can be used to start and stop the animation.
| clearAnimPreload ()
| Removes any AnimPreloadTable associated with the PartBundle.
| clearControlEffects ()
| Sets the control effect of all AnimControls to zero (but does not "stop" the AnimControls).
bool | controlJoint (string joint_name, PandaNode node)
| Specifies that the joint with the indicated name should be animated with the transform on the indicated node.
bool | forceUpdate ()
| Updates all the parts in the bundle to reflect the data for the current frame, whether we believe it needs it or not.
bool | freezeJoint (string joint_name, float value)
| Specifies that the joint with the indicated name should be frozen with the specified transform.
bool | freezeJoint (string joint_name, VBase3 const pos, VBase3 const hpr, VBase3 const scale)
| Specifies that the joint with the indicated name should be frozen with the specified transform.
bool | freezeJoint (string joint_name, TransformState const transform)
| Specifies that the joint with the indicated name should be frozen with the specified transform.
bool | getAnimBlendFlag ()
| Returns whether the character allows multiple different animations to be bound simultaneously.
AnimPreloadTable const | getAnimPreload ()
| Returns the AnimPreloadTable associated with the PartBundle.
BlendType | getBlendType ()
| Returns the algorithm that is used when blending multiple frames or multiple animations together, when either anim_blend_flag or frame_blend_flag is set to true.
float | getControlEffect (AnimControl control)
| Returns the amount by which the character is affected by the indicated AnimControl and its associated animation.
bool | getFrameBlendFlag ()
| Returns whether the character interpolates (blends) between two sequential animation frames, or whether it holds the current frame until the next one is ready.
PartBundleNode | getNode (int n)
| Returns the nth PartBundleNode associated with this PartBundle.
list | getNodes ()
int | getNumNodes ()
| Returns the number of PartBundleNodes that contain a pointer to this PartBundle.
Mat4 const | getRootXform ()
| Returns the transform matrix which is implicitly applied at the root of the animated hierarchy.
AnimControl | loadBindAnim (PandaLoader loader, Filename const filename, int hierarchy_match_flags, PartSubset const subset, bool allow_async)
| Binds an animation to the bundle.
| mergeAnimPreloads (PartBundle const other)
| Copies the contents of the other PartBundle's preload table into this one.
AnimPreloadTable | modifyAnimPreload ()
| Returns a modifiable pointer to the AnimPreloadTable associated with the PartBundle, if any.
| output (ostream out)
| Writes a one-line description of the bundle.
bool | releaseJoint (string joint_name)
| Releases the named joint from the effects of a previous call to freeze_joint() or control_joint().
| setAnimBlendFlag (bool anim_blend_flag)
| Defines the way the character responds to multiple calls to set_control_effect()).
| setAnimPreload (AnimPreloadTable table)
| Replaces the AnimPreloadTable associated with the PartBundle.
| setBlendType (BlendType bt)
| Defines the algorithm that is used when blending multiple frames or multiple animations together, when either anim_blend_flag or frame_blend_flag is set to true.
| setControlEffect (AnimControl control, float effect)
| Sets the amount by which the character is affected by the indicated AnimControl (and its associated animation).
| setFrameBlendFlag (bool frame_blend_flag)
| Specifies whether the character interpolates (blends) between two sequential frames of an active animation, showing a smooth intra-frame motion, or whether it holds each frame until the next frame is ready, showing precisely the specified animation.
| setRootXform (Mat4 const root_xform)
| Specifies the transform matrix which is implicitly applied at the root of the animated hierarchy.
bool | update ()
| Updates all the parts in the bundle to reflect the data for the current frame (as set in each of the AnimControls).
| waitPending ()
| Blocks the current thread until all currently-pending AnimControls, with a nonzero control effect, have been loaded and are properly bound.
| xform (Mat4 const mat)
| Applies the indicated transform to the root of the animated hierarchy.
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

This is the root of a MovingPart hierarchy.

It defines the hierarchy of moving parts that make up an animatable object.

## Member Enumeration Documentation

enum BlendType

Enumerator:

  BTLinear |
  BTNormalizedLinear |
  BTComponentwise |
  BTComponentwiseQuat |

## Constructor & Destructor Documentation

PartBundle | ( | string | name | ) |

Normally, a PartBundle constructor should not be called directly--it will get created when a PartBundleNode is created.

PartBundle | ( |  | ) |

Normally, a PartBundle constructor should not be called directly--it will get created when a PartBundleNode is created.

## Member Function Documentation

PartBundle applyTransform | ( | TransformState const | transform | ) |

Returns a PartBundle that is a duplicate of this one, but with the indicated transform applied.

If this is called multiple times with the same TransformState pointer, it returns the same PartBundle each time.

AnimControl bindAnim | ( | AnimBundle | anim,
|  | int | hierarchy_match_flags,
|  | PartSubset const | subset
| ) |  |

Binds the animation to the bundle, if possible, and returns a new AnimControl that can be used to start and stop the animation.

If the anim hierarchy does not match the part hierarchy, returns NULL.

If hierarchy_match_flags is 0, only an exact match is accepted; otherwise, it may contain a union of PartGroup.HierarchyMatchFlags values indicating conditions that will be tolerated (but warnings will still be issued).

If subset is specified, it restricts the binding only to the named subtree of joints.

The AnimControl is not stored within the PartBundle; it is the user's responsibility to maintain the pointer. The animation will automatically unbind itself when the AnimControl destructs (i.e. its reference count goes to zero).

AnimControl bindAnim | ( | AnimBundle | anim,
|  | int | hierarchy_match_flags
| ) |  |

Binds the animation to the bundle, if possible, and returns a new AnimControl that can be used to start and stop the animation.

If the anim hierarchy does not match the part hierarchy, returns NULL.

If hierarchy_match_flags is 0, only an exact match is accepted; otherwise, it may contain a union of PartGroup.HierarchyMatchFlags values indicating conditions that will be tolerated (but warnings will still be issued).

If subset is specified, it restricts the binding only to the named subtree of joints.

The AnimControl is not stored within the PartBundle; it is the user's responsibility to maintain the pointer. The animation will automatically unbind itself when the AnimControl destructs (i.e. its reference count goes to zero).

AnimControl bindAnim | ( | AnimBundle | anim | ) |

Binds the animation to the bundle, if possible, and returns a new AnimControl that can be used to start and stop the animation.

If the anim hierarchy does not match the part hierarchy, returns NULL.

If hierarchy_match_flags is 0, only an exact match is accepted; otherwise, it may contain a union of PartGroup.HierarchyMatchFlags values indicating conditions that will be tolerated (but warnings will still be issued).

If subset is specified, it restricts the binding only to the named subtree of joints.

The AnimControl is not stored within the PartBundle; it is the user's responsibility to maintain the pointer. The animation will automatically unbind itself when the AnimControl destructs (i.e. its reference count goes to zero).

clearAnimPreload | ( |  | ) |

Removes any AnimPreloadTable associated with the PartBundle.

clearControlEffects | ( |  | ) |

Sets the control effect of all AnimControls to zero (but does not "stop" the AnimControls).

The character will no longer be affected by any animation, and will return to its default pose (unless restore-initial-pose is false).

The AnimControls which are no longer associated will not be using any CPU cycles, but they may still be in the "playing" state; if they are later reassociated with the PartBundle they will resume at their current frame as if they'd been running all along.

bool controlJoint | ( | string | joint_name,
|  | PandaNode | node
| ) |  |

Specifies that the joint with the indicated name should be animated with the transform on the indicated node.

It will henceforth always follow the node's transform, regardless of any animations that may subsequently be bound to the joint.

Returns true if the joint is successfully controlled, or false if the named child is not a joint (or slider) or does not exist.

bool forceUpdate | ( |  | ) |

Updates all the parts in the bundle to reflect the data for the current frame, whether we believe it needs it or not.

bool freezeJoint | ( | string | joint_name,
|  | VBase3 const | pos,
|  | VBase3 const | hpr,
|  | VBase3 const | scale
| ) |  |

Specifies that the joint with the indicated name should be frozen with the specified transform.

It will henceforth always hold this fixed transform, regardless of any animations that may subsequently be bound to the joint.

Returns true if the joint is successfully frozen, or false if the named child is not a joint (or slider) or does not exist.

bool freezeJoint | ( | string | joint_name,
|  | float | value
| ) |  |

Specifies that the joint with the indicated name should be frozen with the specified transform.

It will henceforth always hold this fixed transform, regardless of any animations that may subsequently be bound to the joint.

Returns true if the joint is successfully frozen, or false if the named child is not a joint (or slider) or does not exist.

bool freezeJoint | ( | string | joint_name,
|  | TransformState const | transform
| ) |  |

Specifies that the joint with the indicated name should be frozen with the specified transform.

It will henceforth always hold this fixed transform, regardless of any animations that may subsequently be bound to the joint.

Returns true if the joint is successfully frozen, or false if the named child is not a joint (or slider) or does not exist.

bool getAnimBlendFlag | ( |  | ) |

Returns whether the character allows multiple different animations to be bound simultaneously.

See set_anim_blend_flag().

AnimPreloadTable const getAnimPreload | ( |  | ) |

Returns the AnimPreloadTable associated with the PartBundle.

This table, if present, can be used for the benefit of load_bind_anim() to allow asynchronous binding.

BlendType getBlendType | ( |  | ) |

Returns the algorithm that is used when blending multiple frames or multiple animations together, when either anim_blend_flag or frame_blend_flag is set to true.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from PartGroup.

Reimplemented in CharacterJointBundle.

float getControlEffect | ( | AnimControl | control | ) |

Returns the amount by which the character is affected by the indicated AnimControl and its associated animation.

See set_control_effect().

bool getFrameBlendFlag | ( |  | ) |

Returns whether the character interpolates (blends) between two sequential animation frames, or whether it holds the current frame until the next one is ready.

See set_frame_blend_flag().

PartBundleNode getNode | ( | int | n | ) |

Returns the nth PartBundleNode associated with this PartBundle.

Reimplemented in CharacterJointBundle.

list getNodes | ( |  | ) |

int getNumNodes | ( |  | ) |

Returns the number of PartBundleNodes that contain a pointer to this PartBundle.

Mat4 const getRootXform | ( |  | ) |

Returns the transform matrix which is implicitly applied at the root of the animated hierarchy.

AnimControl loadBindAnim | ( | PandaLoader | loader,
|  | Filename const | filename,
|  | int | hierarchy_match_flags,
|  | PartSubset const | subset,
|  | bool | allow_async
| ) |  |

Binds an animation to the bundle.

The animation is loaded from the disk via the indicated Loader object. In other respects, this behaves similarly to bind_anim(), with the addition of asynchronous support.

If allow_aysnc is true, the load will be asynchronous if possible. This requires that the animation basename can be found in the PartBundle's preload table (see get_anim_preload()).

In an asynchronous load, the animation file will be loaded and bound in a sub-thread. This means that the animation will not necessarily be available at the time this method returns. You may still use the returned AnimControl immediately, though, but no visible effect will occur until the animation eventually becomes available.

You can test AnimControl.is_pending() to see if the animation has been loaded yet, or wait for it to finish with AnimControl.wait_pending() or even PartBundle.wait_pending(). You can also set an event to be triggered when the animation finishes loading with AnimControl.set_pending_done_event().

mergeAnimPreloads | ( | PartBundle const | other | ) |

Copies the contents of the other PartBundle's preload table into this one.

AnimPreloadTable modifyAnimPreload | ( |  | ) |

Returns a modifiable pointer to the AnimPreloadTable associated with the PartBundle, if any.

output | ( | ostream | out | ) |

Writes a one-line description of the bundle.

Reimplemented from Namable.

bool releaseJoint | ( | string | joint_name | ) |

Releases the named joint from the effects of a previous call to freeze_joint() or control_joint().

It will henceforth once again follow whatever transforms are dictated by the animation.

Returns true if the joint is released, or false if the named child was not previously controlled or frozen, or it does not exist.

setAnimBlendFlag | ( | bool | anim_blend_flag | ) |

Defines the way the character responds to multiple calls to set_control_effect()).

By default, this flag is set false, which disallows multiple animations. When this flag is false, it is not necessary to explicitly set the control_effect when starting an animation; starting the animation will implicitly remove the control_effect from the previous animation and set it on the current one.

However, if this flag is set true, the control_effect must be explicitly set via set_control_effect() whenever an animation is to affect the character.

setAnimPreload | ( | AnimPreloadTable | table | ) |

Replaces the AnimPreloadTable associated with the PartBundle.

setBlendType | ( | BlendType | bt | ) |

Defines the algorithm that is used when blending multiple frames or multiple animations together, when either anim_blend_flag or frame_blend_flag is set to true.

See partBundle.h for a description of the meaning of each of the BlendType values.

setControlEffect | ( | AnimControl | control,
|  | float | effect
| ) |  |

Sets the amount by which the character is affected by the indicated AnimControl (and its associated animation).

Normally, this will only be zero or one. Zero indicates the animation does not affect the character, and one means it does.

If the _anim_blend_flag is not false (see set_anim_blend_flag()), it is possible to have multiple AnimControls in effect simultaneously. In this case, the effect is a weight that indicates the relative importance of each AnimControl to the final animation.

setFrameBlendFlag | ( | bool | frame_blend_flag | ) |

Specifies whether the character interpolates (blends) between two sequential frames of an active animation, showing a smooth intra-frame motion, or whether it holds each frame until the next frame is ready, showing precisely the specified animation.

When this value is false, the character holds each frame until the next is ready. When this is true, the character will interpolate between two consecutive frames of animation for each frame the animation is onscreen, according to the amount of time elapsed between the frames.

The default value of this flag is determined by the interpolate-frames Config.prc variable.

Use set_blend_type() to change the algorithm that the character uses to interpolate matrix positions.

setRootXform | ( | Mat4 const | root_xform | ) |

Specifies the transform matrix which is implicitly applied at the root of the animated hierarchy.

bool update | ( |  | ) |

Updates all the parts in the bundle to reflect the data for the current frame (as set in each of the AnimControls).

Returns true if any part has changed as a result of this, or false otherwise.

waitPending | ( |  | ) |

Blocks the current thread until all currently-pending AnimControls, with a nonzero control effect, have been loaded and are properly bound.

xform | ( | Mat4 const | mat | ) |

Applies the indicated transform to the root of the animated hierarchy.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties